#include "MyHeader.h"

main(int argc, char *argv[])
{
 int sock,
     val,
     cnt;

 struct sockaddr_in myname;
 struct sockaddr_in *nptr;
 
 char buf[MAXSIZE];

 struct hostent *hp, *gethostbyaddr();

 if(argc<3)
 {
  printf("network client failure: required parameters");
  printf(" missing from the command line\n");
  printf("network client: usage");
  printf("[executable-name][host name][port number]\n");
  exit(1);
 }

 if((sock=socket(AF_INET, SOCK_STREAM,IPPROTO_TCP))<0)
 {
  printf("network client socket failure %d\n",errno);
  perror("network client");
  exit(2);
 }

 myname.sin_port=htons(atoi(argv[2]));
 myname.sin_family=AF_INET;

 printf("network client %s will try to connect to host %s\n",
        argv[0],argv[1]);
 printf("network client %s will use port number %d\n",argv[0],
        ntohs(myname.sin_port));

 hp=gethostbyname(argv[1]);
 
 if(hp==NULL)
 {
  printf("network client gethostbyname failure %d\n",
         errno);
  perror("network client");
  close(sock);
  exit(3);
 }
 else
 {
  printf("\nServer information obtained via");
  printf(" gethostbyname:\n");
  printf("\tThe official host name is %s\n",hp->h_name);
  printf("\tThe address type is %d\n",hp->h_addrtype);
  printf("\tThe length of the address is %d bytes\n",hp->h_length);
  printf("\tAlias names for the host are:\n");
  while(*hp->h_aliases)
    printf("\t\t%s\n",*hp->h_aliases++);
 }

 bcopy(hp->h_addr_list[0],&myname.sin_addr,hp->h_length);
 
 printf("\nInformation provided in client's");
 printf(" connect request\n");
 printf("\tRemote host address is %lx\n",
        ntohl(myname.sin_addr.s_addr));
 printf("\tPort number supplied is %d\n",ntohs(myname.sin_port));
 printf("\tInternet family ID is %d\n",myname.sin_family);
 printf("\tsin_zero character string is: %s\n",
        myname.sin_zero);

 if((connect(sock,(struct sockaddr *)&myname,sizeof(myname)))<0)
 {
  printf("network client %s connect failure %d\n",
         argv[0],errno);
  perror("network client");
  exit(4);
 }

 bzero(buf,sizeof(buf));
 strcpy(buf,"Message from client to server");
 write(sock,buf,sizeof(buf));
 
 if((cnt=read(sock,buf,sizeof(buf)))<0)
 {
  printf("network client socket read failure &d\n",errno);
  perror("network client");
  close(sock);
  exit(5);
 }
 else
  printf("network client received the message %s\n",buf);

 bzero(buf,sizeof(buf));
 write(sock,buf,0);
 close(sock);
 exit(0);
}

