#include "MyHeader.h"

main(int argc, char *argv[])
{
 int rc,
     new_sd, sock,
     adrlen, cnt;
 struct sockaddr_in myname;
 struct sockaddr_in *nptr;
 struct sockaddr addr;

 char buf[MAXSIZE];
 
 struct hostent *hp, *gethostbyaddr();

 printf("\nThis is the network server with pid %d\n",getpid());
 
 if((sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
 {
  printf("network server socket failure %d\n",errno);
  printf("network server");
  exit(1);
 }
 
 myname.sin_family = AF_INET;
 myname.sin_port = 0;
 myname.sin_addr.s_addr = INADDR_ANY;

 if(bind(sock,(struct sockaddr *)&myname, sizeof(myname))<0)
 {
  close(sock);
  printf("network server bind failure %d\n",errno);
  perror("network server");
  exit(2);
 }

 adrlen = sizeof(addr);

 if((rc = getsockname(sock,(struct sockaddr *)&addr,(socklen_t *)&adrlen))<0)
 {
  printf("setwork server getsockname failure %d\n",errno);
  perror("network server");
  close(sock);
  exit(3);
 }

 printf("\nAfter getsockname():");
 printf(" server listen socket data\n");
 printf("\taddr.sa_family field value is: %d\n",addr.sa_family);
 printf("\taddr.sa_data string is %d bytes long;\n", sizeof(addr.sa_data));
 printf("\taddr.sa_data string is:");
 for(cnt=0;cnt<sizeof(addr.sa_data);cnt++)
   printf(" %x",addr.sa_data[cnt]);
 printf("\n");

 nptr = (struct sockaddr_in *) &addr;
 printf("\n\tnetwork server: server has port number:%d\n",
        ntohs(nptr->sin_port));

 if(listen(sock,5)<0)
 {
  printf("network server bind failure %d\n",errno);
  perror("network server");
  close(sock);
  exit(4);
 }

 printf("Server has set up client socket with values:\n");
 printf("\tInternet address is %lx\n",myname.sin_addr.s_addr);
 printf("\tPort number used is %d\n",myname.sin_port);
 printf("\tInternet family ID is %d\n",myname.sin_family);
 printf("\tValues are filled in after connection request ");
 printf("is accepted");
 
 while(1)
 {
  if((new_sd=accept(sock,0,0))<0)
  {
   printf("network server accept failure %d\n",errno);
   perror("network server");
   close(sock);
   exit(5);
  }
  
  if((fork()) == 0)
  {
   int pid;
   pid = getpid();
   close(sock);
  
   if((rc=getpeername(new_sd,(struct sockaddr *)&addr,(socklen_t *)&adrlen))<0)
   {
    printf("network server %d getpeername failure %d\n",pid,errno);
    perror("network server");
    close(new_sd);
    exit(6);
   }
 
   printf("\n\tnetwork server %d:",pid);
   printf(" client socket from host %s\n",
          inet_ntoa(nptr->sin_addr));
   printf("\t has port number %d\n",nptr->sin_port);
   unsigned int value=4;

   do
   {
    bzero(buf,sizeof(buf));
    if((cnt=read(new_sd,buf,sizeof(buf)))<0)
    {
     printf("network server %d ",pid);
     printf("socket read failure &d\n",errno);
     perror("network server");
     close(new_sd);
     exit(7);
    }
    else if(cnt == 0)
    {
     printf("network server received message");
     printf(" of length %d\n",cnt);
     printf("network server closing");
     printf(" client connection..\n");
     close(new_sd);
     continue;
    }
    else
    {
     printf("network server %d received message",pid);
     printf(" of length %d\n",cnt);
     printf("network server %d received", pid);
     bzero(buf,sizeof(buf));
     strcpy(buf,"Message from server to client");
     write(new_sd,buf,sizeof(buf));
    }
   } while(cnt!=0);

   exit(0); // Exit child process  
  }
  else
    close(new_sd); // parent does not need the socket 
 }
}

